extends Node2D

signal method_called

@onready var _animation_player := $AnimationPlayer as AnimationPlayer
@onready var _animation_tree := $AnimationTree as AnimationTree
@onready var _animation_tree_state_machine := $AnimationTreeStateMachine as AnimationTree
@onready var _playback := _animation_tree_state_machine.get("parameters/playback") \
		as AnimationNodeStateMachinePlayback

# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	pass # Replace with function body.


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta: float) -> void:
	pass


func _unhandled_input(event: InputEvent) -> void:
	if event.is_action_pressed("ui_up"):
		_use_animation_player()
	elif event.is_action_pressed("ui_right"):
		_use_animation_tree_blend_tree()
	elif event.is_action_pressed("ui_down"):
		_use_animation_tree_state_machine()
		pass


func print_oh_my() -> void:
	print("Oh My! Such a mistake!")
	method_called.emit()


func _use_animation_player() -> void:
	_animation_tree.active = false
	_animation_tree_state_machine.active = false
	_animation_player.play("blush")
	await method_called
	_animation_player.play("unblush")


func _use_animation_tree_blend_tree() -> void:
	_animation_tree.active = true
	_animation_tree_state_machine.active = false
	pass


func _use_animation_tree_state_machine() -> void:
	_animation_tree.active = false
	_animation_tree_state_machine.active = true
	_playback.travel("blush")
	await method_called
	_playback.travel("unblush")
